cakecolor={}

local last=0

local function strategy()
 local c={0}
 local last=0
 local i=1

 local inv={}
 inv[0]=1

 coroutine.yield(i,last)

 while true do
  local n=last+0.5
  if n >= 1 then n=n-1 end
  if inv[n]
  then
   local next1,next2,smallest = 1,1,1
   for k,v in pairs(c) do 
    if v > 0 and v < smallest then smallest = v end
    if v > last and v < next1 
    then 
      next2 = next1 
      next1 = v
    elseif v > last and v < next2
     then 
      next2 = v
    end
   end

   if next1 == 1 
   then
    n=(smallest+1)/2 
   elseif next2 == 1 
   then
    n = next1/2
   else
    n = (next1+next2+1)/2 
    if n >= 1 then n=n-1 end
   end
   
  end
  last=n
  i=i+1
  c[i]=last
  inv[last]=i
  coroutine.yield(i,last)
 end
end

local iterator=coroutine.wrap(strategy)

local hsv={
 [0]=function (f)  return 1,f,0 end,
 function (f) return 1-f,1,0 end,
 function (f) return 0,1,f end,
 function (f) return 0,1-f,1 end,
 function (f) return f,0,1 end,
 function (f) return 1,0,1-f end,
}

local function H11toRGB(h) --from HSV where S=V=1 and 0<=H<1
 local hi=math.floor(h*6)
 local f=h*6-hi
 r,g,b=hsv[hi](f)
 return math.ceil(255*r),math.ceil(255*g),math.ceil(255*b)
end

setmetatable(cakecolor,{__index=
 function (t,i)
 if type(i) == "number" then
  while last < i do
   last,h = iterator()
   cakecolor[last]={hue=h,H11toRGB(h)}
  end 
  return cakecolor[last]
 end end})
